SIGPAUSE(3)

NAME
sigpause - atomically release blocked signals and wait for interrupt

SYNOPSIS
#include <signal.h>

int sigpause(int sigmask);  /* BSD */

int sigpause(int sig);      /* System V / Unix95 */

DESCRIPTION
Don't use this function. Use sigsuspend(2) instead.

The function sigpause() is designed to wait for some signal. It changes the process's signal mask (set of blocked signals), and then waits for a signal to arrive. Upon arrival of a signal, the original signal mask is restored.

RETURN VALUE
If sigpause() returns, it was interrupted by a signal and the return value is -1 with errno set to EINTR.

CONFORMING TO
The System V version of sigpause() is standardized in POSIX.1-2001.

NOTES

  History
The classical BSD version of this function appeared in 4.2BSD. It sets the process's signal mask to sigmask. Unix95 standardized the incompatible System V version of this function, which removes only the specified signal sig from the process's signal mask. The unfortunate situation with two incompatible functions with the same name was solved by the sigsuspend(2) function, that takes a sigset_t * parameter (instead of an int).

  Linux Notes
On Linux, this routine is a system call only on the Sparc (sparc64) architecture. Libc4 and libc5 only know about the BSD version. Glibc uses the BSD version if the _BSD_SOURCE feature test macro is defined and none of _POSIX_SOURCE, _POSIX_C_SOURCE, _XOPEN_SOURCE, _GNU_SOURCE, or _SVID_SOURCE is defined. The System V version is used if _XOPEN_SOURCE is defined.

SEE ALSO
kill(2), sigaction(2), sigprocmask(2), sigsuspend(2), sigblock(3), sigvec(3), feature_test_macros(7)